
#ifndef FLAGS_H
#define FLAGS_H

/* Flags */

/* General Purpose */

#define F_KILLED         (1<<0)

/* bbl ins  */

#define F_REFQUAD        (1<<1)
#define F_GPREL32        (1<<2)
#define F_RELOC          (F_REFQUAD|F_GPREL32)
#define F_MARKED         (1<<3)

/* LOCAL FLAGS */

#define F_LOCAL_1       (1<<4)
#define F_LOCAL_2       (1<<5)
#define F_LOCAL_3       (1<<6)
#define F_LOCAL_4       (1<<7)

/* ins */

#define FI_FUN_BEG       (1<<4)
#define FI_FUN_END       (1<<5)                         
#define FI_BBL_BEG       (1<<6)
#define FI_BBL_END       (1<<7)

#define FI_DEF_A         (1<<8)
#define FI_DEF_B         (1<<9)

#define FI_EVAL_A        (1<<10)
#define FI_EVAL_B        (1<<11)
#define FI_EVAL_C        (1<<12)


#define FI_CHANGED       (1<<13)
#define FI_LAST          (1<<14)

/* bbl */

#define FB_ALIGNED_2     (1<<8)
#define FB_ALIGNED_4     (1<<9)
#define FB_ALIGNED FB_ALIGNED_4
#define FB_CRIT_PATH     (1<<10)
#define FB_CRITICAL      (1<<11)
#define FB_SCHEDULED     (1<<12)
#define FB_LOOP_HEADER   (1<<13)
#define FB_CRIT_ESC      (1<<14)
#define FB_PROG_ENTRY    (1<<15)

/* fun */

#define FF_STK_INVALID   (1<<9)
#define FF_STK_ARG       (1<<10)
#define FF_STK_ALIAS     (1<<11)
#define FF_SETJMP        (1<<13)
#define FF_LONGJMP       (1<<14)
#define FF_PSEUDO        (1<<15)

/* edg */

#define FE_RECURSIVE     (1<<9)
#define FE_INLINABLE     (1<<10)

/* edg types */

#define ET_FUN_CALL      'C'
#define ET_JUMP          'J'
#define ET_TRUE          'T'
#define ET_FALSE         'F'
#define ET_UNCOND        'U'
#define ET_NORM          'N'
#define ET_FUN_RETURN    'R' 
#define ET_SWITCH        'S'
#define ET_FUN_LINK      'L'
#define ET_HELL          'H'   
#define ET_EXIT_LINK     'E'
#define ET_SETLONGJMP    'Y'
#define ET_COMPENSATE    'P'
#define ET_EXTRA         'X'

/* bbl types */

#define BT_CALL          'C'
#define BT_JUMP          'J'
#define BT_NORM          'N'
#define BT_BRANCH        'B'
#define BT_UNCOND        'U' 
#define BT_RET           'R'
#define BT_HALT          'H'
#define BT_EXIT          'E'
#define BT_SWITCH        'S'
#define BT_EXTRA         'X'
#define BT_PAL           'P'

/* stk */


/* #define FS_REFERENCE     (1<<0)*/ /* is referenced */


#define FS_SAV_FIRST     (1<<1) /* is saved in first bbl */
#define FS_SAV_NON_FIRST (1<<2) /* is saved in non-first bbl */
#define FS_RES_LAST      (1<<3) /* is restored in last bbl */
#define FS_RES_NON_LAST  (1<<4) /* is restored in non-last bbl */


/* data types */

#define DT_BYTE          'B'
#define DT_WORD          'W'
#define DT_LONG          'L'
#define DT_QUAD          'Q'
#define DT_SFLT          'S'  /* 32 bit ieee */
#define DT_TFLT          'T'  /* 64 bit ieee */
#define DT_FFLT          'F'  /* 32 bit vax */
#define DT_GFLT          'G'  /* 64 bit vax */

/* pipelines */

#define PIPE_E0    (1<<0)
#define PIPE_E1    (1<<1)
#define PIPE_FA    (1<<2)
#define PIPE_FM    (1<<3)

/* constraint types */

#define CT_REG_PROD_CONS 1
#define CT_REG_PROD_PROD 2
#define CT_REG_CONS_PROD 3
#define CT_RES_PROD_CONS 4
#define CT_RES_PROD_PROD 5
#define CT_RES_CONS_PROD 6
#define CT_MEMORY        7
#define CT_HINT          8
#define CT_CONTROL       9

/* #define F_D_FLOAT almost same as T_G_FLOAT */


#define IT_MSC   1    /* trapb,excb,rpcc,amask,implver */
#define IT_LDA   2    /* lda, ldah */

#define IT_ILD   3    /* ldl,ldq,lduw,ldub */
#define IT_FLD   4    /* ldf,lds,ldg,ldt */
#define IT_ULD   5    /* ldq_u */
#define IT_LLD   6    /* ldl_l,ldq_l */

#define IT_IST   7    /* stq,stl,stw,stb */
#define IT_FST   8    /* stf,sts,stg,stt */
#define IT_UST   9    /* stq_u */
#define IT_CST  10    /* stq_c,stl_c */

#define IT_IBR  11    /* blbc,beq,blt,ble,blbs,bne,bge,bgt */
#define IT_FBR  12    /* fbeq,fblt,fble,fbne,fbge,fbgt */
#define IT_BRA  13    /* bra,bsr */
#define IT_JMP  14    /* jmp,jsr,ret,jsr_co */


#define IT_ICM  15    /* cmovlbc,cmoveq,cmovlt,cmovle,cmovlbs,cmovne,cmovge,cmovgt */
#define IT_FCM  16    /* fcmoveq,fcmovlt,fcmovle,fcmovne,fcmovge,fcmovgt */

#define IT_ICP  17    /* cmpbge,cmpult,cmpeq,cmpule,cmplt,cmple */
#define IT_FCP  18    /* cmpt?? cmpg?? */

#define IT_FM4  19    /* muls?,mulf? */
#define IT_FM8  20    /* mult?,mulg? */
#define IT_FD4  21    /* divs?,divf? */
#define IT_FD8  22    /* divt?,divg? */

#define IT_F2I  23    /* ftois,ftoit */ 
#define IT_I2F  24    /* itofs,itoff,itoft */

         
#define IT_LOG  25    /* and,bic,bis,ornot,xor,eqv */
#define IT_SFT  26    /* msk??,ins??,ext??,zap??,s?? */
                        
#define IT_MLL  27    /* mull,mull/v */
#define IT_MLQ  28    /* mulq,mulq/v */
#define IT_MLH  29    /* umulh */

#define IT_IOP  30    /* rest */
#define IT_FOP  31    /* rest */

#define IT_RX   32    /* rc,rs */

#define IT_FCY  33    /* cpys */

#define IT_MEM  34    /* mb,wmb,fetch,fetch_m */

#define IT_EXT  35    /* sextb,sextw */

#define IT_PAL  36    /* call_pal */

#define IT_F2R  37    /* mt_fpcr */

#define IT_R2F  38    /* mf_fpcr */

#define IT_ERR  64    /* error condition */

#define IT_X10  100
#define IT_X11  101
#define IT_X12  102
#define IT_X13  103
#define IT_X14  104
#define IT_X15  105
#define IT_X16  106
#define IT_X17  107
#define IT_X18  108
#define IT_X1A  109
#define IT_X1C  110

     /* -------------------------------- */
#define RES_TR (1<<0)
#define RES_PC (1<<1)
#define RES_LD (1<<2)
#define RES_ST (1<<3)
#define RES_FP (1<<4)
#define RES_MM (1<<5)
     /* -------------------------------- */

#define CONFLICT_EXACT 3
#define CONFLICT_MATCH 2
#define CONFLICT_MAYBE 1
#define CONFLICT_NO    0



#define NO_SIDE_EFFECT  0
#define LOCAL_ONLY      1   /* stores into a functions's own stack frame */
#define STACK_ONLY      2   /* stores into the stack area, maybe not own frame */
#define GLOBAL_ONLY     3
#define UNKNOWN         4

     /* -------------------------------- */

#define AINS_IS_INT_LOAD(iins) \
(AINS_TYPE(iins)==IT_ILD || AINS_TYPE(iins)==IT_ULD)

#define AINS_IS_FLT_LOAD(iins) (AINS_TYPE(iins)==IT_FLD)

#define AINS_IS_INT_STORE(iins) \
(AINS_TYPE(iins)==IT_IST || AINS_TYPE(iins)==IT_UST)

#define AINS_IS_FLT_STORE(iins) (AINS_TYPE(iins)==IT_FST)

#define AINS_IS_LOAD(ii)  (AINS_TYPE(ii) == IT_ILD || \
                           AINS_TYPE(ii) == IT_FLD || \
			   AINS_TYPE(ii) == IT_ULD || \
			   AINS_TYPE(ii) == IT_LLD)

#define AINS_IS_STORE(ii) (AINS_TYPE(ii) == IT_IST || \
			   AINS_TYPE(ii) == IT_FST || \
			   AINS_TYPE(ii) == IT_UST || \
			   AINS_TYPE(ii) == IT_CST)
     
/*=======================================================
=======================================================*/



#endif /* FLAGS_H */



